package pract09_dyv_2_mayores;

import java.util.Arrays;
import java.util.Random;

/**
 * Programa que compara el algoritmo DyV para la bsqueda de los dos mayores
 * elementos del array con una bsqueda lneal.
 * @author mario
 *
 */
public class PruBusca2Mayores {
	
	/**
	 * Genera un array de nmeros aleatorios en el rango [-n, n]
	 * @param n longitud del array
	 * @param semilla semilla del generador de valores aleatorios
	 * @return array de personas aleatorias
	 */
	private static int[] generaArrayAleatorio(int n, long semilla) {
		int[] a = new int[n];

		Random rand = new Random(semilla);

		for(int i=0; i<n; i++) {
			a[i] = rand.nextInt(2*n) - n; 
		}

		return a;
	}

	/**
	 * Programa que compara la solucin basada en DyV con una bsqueda
	 * lineal.
	 */
	public static void main(String[] args) {
		//int[] a = {-2, 4, -5, 7, 4, 3, 1, 0};
		int[] a = generaArrayAleatorio(2<<22, 3);
		long ini, fin;
		int[] sol;
		
		ini = System.currentTimeMillis();
		sol = Busca2mayores.busca2mayores(a);
		fin = System.currentTimeMillis();
		System.out.println("DyV ("+(fin-ini)+"ms): "+Arrays.toString(sol));
		
		ini = System.currentTimeMillis();
		sol = Busca2mayores.busca2mayoresLineal(a);
		fin = System.currentTimeMillis();
		System.out.println("Lineal ("+(fin-ini)+"ms): "+Arrays.toString(sol));
		
	}

}
